#!/bin/perl
#
# this perl script config.pl created by newperl on
# 09/03/98 by aaron
#
$usage = "$0 file ...";
{#main
  # check if there are no command line arguments at all, print usage
  if ( $#ARGV < 0 ) {
    print "usage: /local/ucsb/bin/newperl new_perl_script_name ...\n";
    exit;
  }

  # do command line processing
  &process_args();

  # process remaining input from command line
  for(;$optind <= $#ARGV; ++$optind){
    &process_file( $ARGV[$optind] );
  }

}#end main

#
# sub to process command line arguments
#
sub process_args(){
 for($optind=0;($optind<=$#ARGV)&&($ARGV[$optind] =~ /^-.*/); ++$optind){
    $arg = $ARGV[$optind];

       if( $arg =~ /^-type/ ) { $type = $ARGV[++$optind]; }
    elsif( $arg =~ /^-var/ )  { $var = $ARGV[++$optind]; }
    elsif( $arg =~ /^-v/ )    { $v = 1; }
    elsif( $arg =~ /^-.*/ )   { printf "unrecognized argument: %s\n", $arg ; }
    else                      { printf "Internal error: \n" ; }
  }
}

# 
# sub to process the input
#
sub process_file(){
  $FI = $_[0];

  # header
  print "static $type $var\[\] = {\n";

  # the below are for opening an input file and processing each line of it
  open(FI);
  while(<FI>){
    ($Type,$Name,$Default,$Desc) = split(/,/);
    print "  { $Type, \"$Name\", (int *) &ci.$Name, $Default, $Desc },\n";
  }
  close(FI);

  print "\};\n";
}
